/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.IntensityEqualizer;

import java.awt.GridBagConstraints;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;
import static org.visnow.vn.lib.basic.filters.IntensityEqualizer.IntensityEqualizerShared.*;

/**
 * @author Bartosz Borucki (babor@icm.edu.pl)
 * Warsaw University, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        fullPaddingCB = new javax.swing.JCheckBox();
        gainPanel = new javax.swing.JPanel();
        gainSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        weightsPanel = new javax.swing.JPanel();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        fullPaddingCB.setText("use full padding");
        fullPaddingCB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fullPaddingCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 5);
        add(fullPaddingCB, gridBagConstraints);

        gainPanel.setMinimumSize(new java.awt.Dimension(200, 70));
        gainPanel.setPreferredSize(new java.awt.Dimension(200, 70));
        gainPanel.setLayout(new java.awt.BorderLayout());

        gainSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("global gain"));
        gainSlider.setMax(2.0F);
        gainSlider.setMin(-2.0F);
        gainSlider.setShowingFields(false);
        gainSlider.setVal(1.0F);
        gainSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                gainSliderStateChanged(evt);
            }
        });
        gainPanel.add(gainSlider, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(gainPanel, gridBagConstraints);

        weightsPanel.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(weightsPanel, gridBagConstraints);

        runButton.setAutoCB(true);
        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void gainSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_gainSliderStateChanged
        if (!gainSlider.isAdjusting())
            parameters.set(GAIN, gainSlider.getVal());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_gainSliderStateChanged

    private void fullPaddingCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fullPaddingCBActionPerformed
        parameters.set(FULL_PADDING, fullPaddingCB.isSelected());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_fullPaddingCBActionPerformed

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.Box.Filler filler1;
    private javax.swing.JCheckBox fullPaddingCB;
    private javax.swing.JPanel gainPanel;
    private org.visnow.vn.gui.widgets.FloatSlider gainSlider;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    private javax.swing.JPanel weightsPanel;
    // End of variables declaration//GEN-END:variables

    private WeightUI[] wuis = null;

    public void recreateGUI(ParameterProxy p)
    {
        weightsPanel.removeAll();
        wuis = null;

        float[] weights = p.get(WEIGHTS);
        wuis = new WeightUI[weights.length];
        for (int i = 0; i < weights.length; i++) {
            wuis[i] = new WeightUI();
            wuis[i].setParameters(parameters);
            wuis[i].setWeightIndex(i);
            wuis[i].addChangeListener(new ChangeListener()
            {
                @Override
                public void stateChanged(ChangeEvent e)
                {
                    runButton.setPendingIfNoAuto();
                }
            });

            GridBagConstraints gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = i;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.weightx = 1.0;
            if (i == weights.length - 1)
                gridBagConstraints.weighty = 1.0;
            weightsPanel.add(wuis[i], gridBagConstraints);
        }
        revalidate();
        repaint();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        if (resetFully) {
            gainSlider.setMin(-2.f);
            gainSlider.setMax(2.f);
            recreateGUI(p);
        }
        fullPaddingCB.setSelected(p.get(FULL_PADDING));
        gainSlider.setVal(p.get(GAIN));
        if (wuis != null) {
            for (int i = 0; i < wuis.length; i++) {
                wuis[i].updateGUI(p);
            }
        }
        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

}
